using Tiger.Communication.Messages.Interfaces;
using Tiger.Communication.Messages.Types;

namespace Tiger.Communication.Messages.Outgoing.Inventory.Achievements;

public class AchievementsScoreComposer : IMessageComposer
{
    private readonly int _score;

    public AchievementsScoreComposer(int score)
    {
        _score = score;
    }

    public OutgoingHeaders Header => OutgoingHeaders.UserAchievementScore;
    public void Compose(ServerMessage message)
    {
        message.AppendInt32(_score);
    }
}